<?php
/**
 * @author       Aicha Vack
 * @package      Joomla.Site
 * @subpackage   com_visforms
 * @link         https://www.vi-solutions.de
 * @license      GNU General Public License version 2 or later; see license.txt
 * @copyright    2018 vi-solutions
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

class VisformsPlaceholderEntryDefault extends VisformsPlaceholderEntry {

    protected static $customParams = array (
        'DISPLAYLABEL' => 'COM_VISFORMS_PLACEHOLDER_PARAM_LABEL',
        'DISPLAYLABELPLUSSPACE' => 'COM_VISFORMS_PLACEHOLDER_PARAM_LABEL_PLUS_SPACE',
    );

	public function getReplaceValue() {
	    // if data is empty, just replace the placeholder with nothing
        if (isset($this->rawData) && ($this->rawData === '')) {
            return '';
        }
        $customParams = self::$customParams;
        if (!empty($this->param) && array_key_exists($this->param, $customParams)) {
            switch ($this->param) {
                case 'DISPLAYLABEL' :
                    return $this->field->label;
                case 'DISPLAYLABELPLUSSPACE' :
                    return $this->field->label . ' ';
                default:
                    return $this->rawData;
            }
        }
        return $this->rawData;
    }
}