<?php

/**
 * Visform field Selectfromdb
 * @package      Joomla.Administrator
 * @subpackage   com_visforms
 * @link         https://www.vi-solutions.de
 * @license      GNU General Public License version 2 or later; see license.txt
 * @copyright    2012 vi-solutions
 */
namespace Visolutions\Component\Visforms\Administrator\Field;

// no direct access
defined('JPATH_PLATFORM') or die;

use Joomla\CMS\Factory;
use Joomla\CMS\Form\Field\ListField;
use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Language\Text;

class VfMenuListField extends ListField
{

	public $type = 'VfMenuList';

	protected function getInput() {
		// Get the field options.
        $options = array_merge($this->getOptions(), $this->getMenuLinkList());
		$data = $this->getLayoutData();
		$data['options'] = (array) $options;
		return $this->getRenderer($this->layout)->render($data);
	}

	private function getMenuLinkList() {
	    $fid = Factory::getApplication()->getInput()->get('fid', 0, 'int');
        $hasSub = \VisformsAEF::checkAEF(\VisformsAEF::$subscription);
	    $options = array();
        // $options[] = array('value' => "index.php?option=com_visforms&view=viscpanel", 'text' => Text::_('COM_VISFORMS_SUBMENU_CPANEL_LABEL'));
        $options[] = array('value' => "index.php?option=com_visforms&view=visforms", 'text' => Text::_('COM_VISFORMS_SUBMENU_FORMS'));
        // $options[] = array('value' => "index.php?option=com_visforms&view=viscreator", 'text' => Text::_('COM_VISFORMS_CREATOR'));
        // $options[] = array('value' => "index.php?option=com_visforms&view=visinspector", 'text' => Text::_('COM_VISFORMS_SUBMENU_INSPECTOR'));
        $options[] = array('value' => "index.php?option=com_visforms&view=visfields&fid=" . $fid, 'text' => Text::_('COM_VISFORMS_FORM_FIELDS'));
        if ($hasSub) {
            $options[] = array('value' => "index.php?option=com_visforms&view=vispdfs&fid=" . $fid, 'text' => Text::_('COM_VISFORMS_PDF_TEMPLATES'));
        }
        $options[] = array('value' => "index.php?option=com_visforms&view=visdatas&fid=" . $fid, 'text' => Text::_('COM_VISFORMS_VISFORMSDATA_VIEW_DEFAULT_TITLE'));
        return $options;
	}
}
